      SUBROUTINE BACKJC (XJC, ND, NF, XJCIND, XLAMBDA, 
     >                   XLAMREF, RADIUS)

C***  CALCULATE THE CONTINUUM INTENSITIES AT THE LINE CENTER FREQUENCIES
C***    BY INTERPOLATION IN THE CURRENT MODEL-FILE DATA, I.E. XJC AS OB
C***    BY THE LAST EXECUTION OF "COMO"
C***    NOTE: EVEN IF THE SUBROUTINE ELIMIN HAS BEEN CALLED, THE
C***          VECTOR XJCIND IS NOW OVERWRITTEN

      DIMENSION XJC(ND,NF), XLAMBDA(NF), XJCIND(ND)
      DIMENSION RADIUS(ND)

C***  FIND THE CONTINUUM FREQUENCY INTERVAL OF PRESENT LINE
      KB = ISRCHFGT(NF,XLAMBDA,1,XLAMREF)
      KA = KB - 1
      IF (KB .EQ. 1 .OR. KB .EQ. NF) THEN
        KA = KB
      ELSE IF (KB .LT. 1 .OR. KB .GT. NF) THEN
        WRITE (0,*) 'SUBR. BACKJC: UNEXPECTED LINE FREQUENCY'
        WRITE (0,*) 'XLAMREF=',XLAMREF
        WRITE (0,*) 'BOUNDARIES: ', XLAMBDA(1), XLAMBDA(NF)
        STOP 'ERROR'
      ENDIF
C***  CALCULATE INTERPOLATION WEIGHTS
      XLAMA = XLAMBDA(KA)
      XLAMB = XLAMBDA(KB)
      IF (XLAMB .NE. XLAMA) THEN
        Q = (XLAMREF - XLAMA) / (XLAMB-XLAMA)
      ELSE
        Q = 0.
      ENDIF

C***  INTERPOLATION AT ALL DEPTH POINTS
C***   NOTE: RADIUS**2 * XJC IS EXPRESSED AS TRAD
      DO 1 L=1, ND

        R2 = RADIUS(L) * RADIUS(L)

        XJCA = XJC(L,KA) * R2
        XJCB = XJC(L,KB) * R2

        TRADA = TRADFUN(XLAMA, XJCA)
        TRADB = TRADFUN(XLAMB, XJCB)
        TRAD = (1.-Q) * TRADA + Q * TRADB
        XJCIND(L) = BNUE(XLAMREF,TRAD) / R2

c        if (xjcind(l) .eq. 0) then
c          write(*,*) 'backjc:',xjca,xjcb,trada,
c     >                tradb,xjcind(l)
c        endif

    1 CONTINUE

      RETURN
      END
