      SUBROUTINE MOMENT0 (ND,R,L,JMAX,Z,XJ,XJMEAN,MODE)
C***********************************************************************
C***  INTEGRATION OF THE ZERO-MOMENT OF THE RADIATION FIELD (MEAN INTENSITY)
C***   IF ( MODE = .TRUE.    ) THE INTEGRATION WEIGHTS ARE GENERATED (VECTOR XJ)
C***   ELSE : XJ IS CONSIDERED AS ANGLE-DEPENDENT INTENSITY AND THE
C***          INTEGRATION IS PERFORMED ( RESULT XJMEAN)
C***  RADIUS-MESH R, ACTUAL INDEX L, AND Z-MESH Z(L,J) ARE GIVEN
C***  WEIGHTS ARE ACCORDING TO TRAPEZOIDAL RULE IN Z=SQRT(R*R-P*P)
C***********************************************************************
 
      DIMENSION R(ND),Z(ND,JMAX),XJ(JMAX)
      LOGICAL MODE
      RL2=2.*R(L)
C***  FIRST STEP
      ZJ=Z(L,1)
      ZNEXT=Z(L,2)
      IF (MODE) XJ(1)=(ZJ-ZNEXT)/RL2
      IF (.NOT.MODE) XJMEAN=(ZJ-ZNEXT)*XJ(1)
C***  MIDDLE STEPS
      DO 1 J=3,JMAX
      ZLAST=ZJ
      ZJ=ZNEXT
      ZNEXT=Z(L,J)
      IF (MODE) XJ(J-1)=(ZLAST-ZNEXT)/RL2
      IF (.NOT.MODE) XJMEAN=XJMEAN+XJ(J-1)*(ZLAST-ZNEXT)
    1 CONTINUE
C***  LAST STEP, IMPLYING Z(L,JMAX)=.0
      IF (MODE) GOTO 2
      XJMEAN=XJMEAN+XJ(JMAX)*ZJ
      XJMEAN=XJMEAN/RL2
      RETURN
    2 XJ(JMAX)=ZJ/RL2
      RETURN
      END
