      SUBROUTINE PRIXDAT(XDATA,MAXXDAT)
C***  CALLED BY WRSTART
C***  PRINT OUT THE X-RAY-DATA

      DIMENSION XDATA(MAXXDAT)

C***  K-BOLTZMANN IN ERG/K
      DATA BOLZK/1.38E-16/

C***  ATOMIC-UNIT IN GR
      DATA AU/2.23E-24/

C***  MEAN PARTICLE MASS OF FULLY IONISIZED HELIUM
      COMION = 4 / 3 * AU
      
      
C***  VECTOR XDATA DEVIDED IN ITS PARTITIONS
      XFILL = XDATA(1)
      XRAYT = XDATA(2)
      XRMIN = XDATA(3)

      XFILL2 = XDATA(5)
      XRAYT2 = XDATA(6)
      XRMIN2 = XDATA(7)

      
C***  PRINTOUT THE X-RAY-INFORMATION
      PRINT 5
    5 FORMAT(/,10X,'INFORMATIONS ABOUT SHOCK-WAVE PARAMETERS : ')

C***  EXIT IF XFILL=0 NO X-RAY-EMISSION
      IF ((XFILL .EQ. 0.)) THEN
        PRINT 10
 10     FORMAT(10X,'NO X-RAY-DATA')
        RETURN

      ELSE

       IF (XFILL .GT. 0.) THEN
        XVELOC = SQRT(3 * BOLZK / COMION * XRAYT)/100000
        PRINT 15,XRAYT,XVELOC,XRMIN,XFILL
 15     FORMAT(/,10X,'X-RAY TEMPERATURE IN K:',E10.3,
     $         /,10X,'THAT MEANS A PARTICLE VELOCITY IN KM/SEC:',F10.2,
     $         /,10X,'MINIMUM RADIUS FOR SHOCKWAVE IN RSTARS:',F6.2,
     $  /,10X,'RELATIV NUMBER OF PARTICLE MAKING BREMSSTRAHLUNG:',E11.4,
     $         /)
       ENDIF

       IF (XDATA(4) .NE. .0) WRITE (*,16) XDATA(4)
 16     FORMAT (10X,'DIFFERENTIAL EMISSION MEASURE EXPONENT:', F5.2)
        WRITE (*,*)

       IF (XFILL2 .GT. 0.) THEN
        XVELOC2 = SQRT(3 * BOLZK / COMION * XRAYT2)/100000
        PRINT 17,XRAYT2,XVELOC2,XRMIN2,XFILL2
 17     FORMAT(/,10X,'X-RAY TEMPERATURE2 IN K:',E10.3,
     $         /,10X,'THAT MEANS A PARTICLE VELOCITY IN KM/SEC:',F10.2,
     $         /,10X,'MINIMUM RADIUS2 FOR SHOCKWAVE IN RSTARS:',F6.2,
     $  /,10X,'RELATIV NUMBER OF PARTICLE MAKING BREMSSTRAHLUNG:',E11.4,
     $         /)
       ENDIF

      ENDIF

      RETURN

      END
